require 'net/http'
require 'openssl'

module EmapicConsul
  class Request
    def initialize(options = {})
      uri = EmapicConsul::Request.build_uri(options[:host], options[:path], options[:port])
      @http = EmapicConsul::Request.build_http_object(uri)
      @request = Net::HTTP::Post.new(uri)
      @request.basic_auth(options[:api_key], options[:api_secret])
    end

    # Usage:
    # request.params = { id: 1, title: 'My title', geoloc: 'xyz' }
    def params=(params)
      @request.set_form_data(params)
    end

    def send
      @http.request(@request)
    end

    def self.build_uri(host, path, port)
      URI::HTTP.build(host: host, path: path, port: port)
    end

    def self.build_http_object(uri)
      http = Net::HTTP.new(uri.host, uri.port)
      http.use_ssl = true
      http.verify_mode = OpenSSL::SSL::VERIFY_NONE
      http
    end
  end
end
